package vavetam.api.structure;


import java.util.List;

import vavetam.implementation.structure.enums.MEPType;

public interface IMapExploratoryProcedure {
	
	/**
	 * 
	 * @return the MEP that is in the primary focus
	 */
	public IReferentialObject getPrimaryFocus();
	
	/**
	 * 
	 * @return a List of MEPs that form the secondary focus
	 */
	public List<IReferentialObject> getSecondaryFocus();
	
	/**
	 * 
	 * @return the Type of this MEP
	 */
	public MEPType getType();
	
	/**
	 * 
	 * @param mep
	 * @return does the primary Focus of this {@link IMapExploratoryProcedure}
	 *         equal the primary focus of the given {@link IMapExploratoryProcedure}
	 */
	public boolean primaryFocusEquals(IMapExploratoryProcedure mep);
	
	/**
	 * computes the differences in the secondary focus of the two {@link IMapExploratoryProcedure}s
	 * @param m
	 * @return
	 */
	public List<IReferentialObject> secondaryFocusDifferences(IMapExploratoryProcedure m);

	public IUtterancePlan getUtterancePlan();

	public void setPreverbalMessages(List<IPreverbalMessage> result);

	public List<IPreverbalMessage> getPreverbalMessages();

	public boolean isCompleted();

}
