package vavetam.implementation.fileio.logging;


import org.apache.log4j.FileAppender;
import org.apache.log4j.spi.ErrorCode;

import vavetam.implementation.startup.Startup;

public class MyFileAppender extends FileAppender {
	
	private static final String sep = " - ";
	
	public void activateOptions() {
		if (fileName != null) {
			try {
				if (fileName != null) {
					final int dotIndex = fileName.lastIndexOf(".");
					if (dotIndex != -1) {
						fileName = new StringBuilder()
							.append(fileName.substring(0, dotIndex))
							.append(sep)
							.append(Startup.startTime)
							.append(fileName.substring(dotIndex))
							.toString();
					} else {
						fileName = new StringBuilder()
							.append(fileName)
							.append(sep)
							.append(Startup.startTime)
							.toString();
					}
				}
				setFile(fileName, fileAppend, bufferedIO, bufferSize);
			} catch (Exception e) {
				errorHandler.error("Error while activating log options", e,
						ErrorCode.FILE_OPEN_FAILURE);
			}
		}
	}
}
