package vavetam.implementation.generation.incremental.heuristic;

import java.util.Comparator;

import org.apache.commons.lang.StringUtils;

import vavetam.api.structure.IFormulation;


/**
 * Für das Sortieren nach "geringste Ähnlichkeit zuerst"
 * 
 * @author Ole Eichhorn
 */
public class DifferenceFirstPreference implements Comparator<IFormulation> {
	
	IFormulation current;
	
	public DifferenceFirstPreference(IFormulation current) {
		this.current = current;
	}

	@Override
	public int compare(IFormulation arg0, IFormulation arg1) {
		int measure0 = StringUtils.indexOfDifference(arg0.getText(), current.getText());
		int measure1 = StringUtils.indexOfDifference(arg1.getText(), current.getText());
		return Integer.signum(measure0-measure1);
	}

}