package vavetam.implementation.startup;


import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import vavetam.api.startup.IVavetam;
import vavetam.api.structure.IMapExploratoryProcedure;
import vavetam.api.structure.IReferentialObject;
import vavetam.implementation.fileio.XMLParser;
import vavetam.implementation.generation.incremental.AbstractPipelineProcessor;
import vavetam.implementation.structure.MapExploratoryProcedure;
import vavetam.implementation.structure.enums.MEPType;


public class Vavetam extends AbstractPipelineProcessor<MapExploratoryProcedure, MapExploratoryProcedure> implements IVavetam {
	
	private Map<String, IReferentialObject> map;
	private Logger log = Logger.getLogger(Vavetam.class);	
	public Vavetam(String mapLocation) {
		try {
			map = (new XMLParser()).parse(new File(mapLocation));
			start();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public void fireMapExploratoryProcedure(IMapExploratoryProcedure mep) {
		log.debug("firing " + mep);
		if (mep instanceof MapExploratoryProcedure) {
			try {
				put((MapExploratoryProcedure) mep);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}		
		} else {
			try {
				put(new MapExploratoryProcedure(mep.getType(), mep.getPrimaryFocus(), mep.getSecondaryFocus()));
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}		
		}
	}

	@Override
	public void fireMapExploratoryProcedure(String type, String primaryFocusID,
			List<String> secondaryFocusIDs) {
		List<IReferentialObject> secFoc = new ArrayList<IReferentialObject>();
		for (String s: secondaryFocusIDs) {
			secFoc.add(map.get(s));
		}
		fireMapExploratoryProcedure(new MapExploratoryProcedure(MEPType.valueOf(type), map.get(primaryFocusID), secFoc));
		
	}

	@Override
	public void fireMapExploratoryProcedure(String type, String primaryFocusID) {
		fireMapExploratoryProcedure(new MapExploratoryProcedure(MEPType.valueOf(type), map.get(primaryFocusID)));
		
	}

	@Override
	public void MapExploratoryProcedureOver() {
		fireMapExploratoryProcedure(new MapExploratoryProcedure());
	}

	public void setOutputChannels(boolean speech, boolean console,
			boolean additionalConsole) {
		// TODO Auto-generated method stub
	}

	@Override
	protected MapExploratoryProcedure process(MapExploratoryProcedure in) {
		return in;
	}

	@Override
	protected String threadName() {
		return "VAVETaM Base Module";
	}

	@Override
	protected Logger getLogger() {
		return log;
	}
}
