package vavetam.implementation.structure;


import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import vavetam.api.structure.IDescriptor;
import vavetam.api.structure.IPredicate;
import vavetam.api.structure.IReferentialObject;
import vavetam.implementation.structure.enums.Definiteness;
import vavetam.implementation.structure.enums.PredicateName;


public class Descriptor extends ArrayList<IPredicate> implements IDescriptor {
	
	private static final long serialVersionUID = 558845123144557563L;
	private Definiteness def;
	
	public Descriptor(Definiteness definiteness) {
		super();
		this.def = definiteness;
	}
	
	public Descriptor(Definiteness definiteness, 
			PredicateName predicateName, List<IReferentialObject> arguments) {
		this(definiteness);
		add(new Predicate(predicateName, arguments));
	}
	
	@Override
	public Definiteness getDefiniteness() {
		return def;
	}

	@Override
	public IPredicate getPredicateAtIndex(int index) {
		return get(index);
	}
	
	@Override
	public String toString() {
		return def.toString() + "[" + StringUtils.join(this, " ^ ") + "]";
	}
}
