package vavetam.implementation.structure;


import java.util.List;

import org.apache.commons.lang3.StringUtils;

import vavetam.api.structure.IPredicate;
import vavetam.api.structure.IReferentialObject;
import vavetam.implementation.structure.enums.PredicateName;


public class Predicate implements IPredicate{
	
	private final List<IReferentialObject> arguments;
	private final PredicateName predicateName;
	
	public Predicate(PredicateName predicateName,
			List<IReferentialObject> arguments) {
		this.arguments = arguments;
		this.predicateName = predicateName;
	}

	@Override
	public List<IReferentialObject> getArguments() {
		return arguments;
	}

	@Override
	public PredicateName getName() {
		return predicateName;
	}
	
	@Override
	public String toString() {
		return predicateName + "(" + StringUtils.join(arguments, ", ") + ")";
	}
}