package vavetam.implementation.structure;


import java.text.MessageFormat;
import java.util.Collections;
import java.util.List;

import vavetam.api.structure.IDescriptor;
import vavetam.api.structure.IMapExploratoryProcedure;
import vavetam.api.structure.IPreverbalMessage;
import vavetam.api.structure.IReferentialObject;
import vavetam.implementation.structure.enums.Intention;


public class PreverbalMessage implements IPreverbalMessage {
	
	private List<IDescriptor> descriptors = Collections.emptyList();
	private IReferentialObject referentialObject;
	private Intention intention;
	private IMapExploratoryProcedure parent;
	private boolean repetition = false;
	
	public PreverbalMessage(IMapExploratoryProcedure mep) {
		this.parent = mep;
	}

	/* (non-Javadoc)
	 * @see implementation.structure.IPreverbalMessage#getDescriptors()
	 */
	@Override
	public List<IDescriptor> getDescriptors() {
		return descriptors;
	}

	/* (non-Javadoc)
	 * @see implementation.structure.IPreverbalMessage#setDescriptors(java.util.List)
	 */
	@Override
	public void setDescriptors(List<IDescriptor> descriptors) {
		this.descriptors = descriptors;
	}

	/* (non-Javadoc)
	 * @see implementation.structure.IPreverbalMessage#getReferentialObject()
	 */
	@Override
	public IReferentialObject getReferentialObject() {
		return referentialObject;
	}

	/* (non-Javadoc)
	 * @see implementation.structure.IPreverbalMessage#setReferentialObject(api.structure.IReferentialObject)
	 */
	@Override
	public void setReferentialObject(IReferentialObject referentialObject) {
		this.referentialObject = referentialObject;
	}

	/* (non-Javadoc)
	 * @see implementation.structure.IPreverbalMessage#getIntention()
	 */
	@Override
	public Intention getIntention() {
		return intention;
	}

	/* (non-Javadoc)
	 * @see implementation.structure.IPreverbalMessage#setIntention(implementation.structure.enums.Intention)
	 */
	@Override
	public void setIntention(Intention intention) {
		this.intention = intention;
	}

	public String toString() {
		return(MessageFormat.format("PreverbalMessage for {0} with {1} and {2} descriptors", referentialObject, intention, descriptors.size()));
	}

	/* (non-Javadoc)
	 * @see implementation.structure.IPreverbalMessage#getMep()
	 */
	@Override
	public IMapExploratoryProcedure getMep() {
		return parent;
	}

	@Override
	public void setRepetition(boolean repetition) {
		this.repetition = repetition;
	}

	@Override
	public boolean isRepetition() {
		return repetition;
	}
}