package vavetam.implementation.structure.enums;

public enum Intention {
	
	/**
	 * Intention 1.1.1 is supposed to identify the given RefO r with a definite identification (e.g.
	 * "this is the town hall")
	 */
	IDENTIFICATION("identification"),
	SPATIAL_RELATIONS("spatial relations"),
	EXTENSION("extension"),
	JUNCTIONS("junctions"),
	GEOMETRIC_RELATIONS("geometric realtions"),
	TEST("test behavior");
	
	private final String screenName;
	
	Intention(String screenName) {
		this.screenName = screenName;
	}
	
	public String getScreenName() {
		return screenName;
	}
	
	@Override
	public String toString() {
		return "Intention: " + screenName;
	}
}
