package vavetam.implementation.structure.util;


import java.util.LinkedList;
import java.util.List;

import vavetam.api.structure.IDescriptor;
import vavetam.api.structure.IReferentialObject;
import vavetam.implementation.structure.enums.PredicateName;


public class ReferentialObjectUtils {

	public static List<IDescriptor> getDescriptorsContainingPredicatesWithName(PredicateName predicateName, IReferentialObject referentialObject) {
		List<IDescriptor> result = new LinkedList<IDescriptor>();
		for (IDescriptor d1: referentialObject.getDescriptors()) {
			if (d1.getPredicateAtIndex(0).getName().equals(PredicateName.STREET)) {
				result.add(d1);
			}
		}
		return result;
	}
}
