package vavetam.oldcode;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.border.BevelBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;

import vavetam.implementation.startup.Vavetam;


/**
 * An instance of the ManualSimulatorWindow can be used to interactively
 * produce input for the VAVETaM system. It has an own GUI.
 * 
 * @author Ole Eichhorn
 *
 */
public class ManualSimulatorWindow extends JFrame {

	private static final long serialVersionUID = 7816813314148106103L;
	private JPanel contentPane;
	private JPanel panel;
	private JButton pt1;
	private JButton pt2;
	private JButton pt3;
	private JButton plm1;
	private JButton plm2;
	private JButton pts11;
	private JButton pfr;
	private JTextField textField;
	private JButton other;
	private JToggleButton toggleCons;
	private JToggleButton toggleAddCons;
	private JToggleButton toggleSpeech;
	private JPanel panel_1;
	private ButtonGroup bg;
	
	Vavetam _v;
	private JRadioButton track;
	private JRadioButton landmark;
	private JRadioButton region;
	private JRadioButton frame;
	private JRadioButton stop;

	/**
	 * Create the frame.
	 */
	public ManualSimulatorWindow(Vavetam v) {
		setTitle("MEP Simulator");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 501, 370);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		addWindowListener(new WindowAdapter() {
			
			@Override
			public void windowClosing(WindowEvent e) {
				_v.stop();
			}
		});
		
		panel = new JPanel();
		panel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null), "MEPs feuern", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 232, 314);
		contentPane.add(panel);
		panel.setLayout(null);
		
		pt1 = new JButton("pt1 feuern");
		pt1.setBounds(10, 27, 213, 23);
		panel.add(pt1);
		pt1.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				fire("pt1");
			}
		});
		
		pt2 = new JButton("pt2 feuern");
		pt2.setBounds(10, 50, 213, 23);
		panel.add(pt2);
		pt2.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				fire("pt2");
			}
		});
		
		pt3 = new JButton("pt3 feuern");
		pt3.setBounds(10, 73, 213, 23);
		panel.add(pt3);
		pt3.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				fire("pt3");
			}
		});
		
		plm1 = new JButton("plm1 feuern");
		plm1.setBounds(10, 96, 213, 23);
		panel.add(plm1);
		plm1.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				fire("plm1");
			}
		});
		
		plm2 = new JButton("plm2 feuern");
		plm2.setBounds(10, 119, 213, 23);
		panel.add(plm2);
		plm2.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				fire("plm2");
			}
		});
		
		pts11 = new JButton("pts11 feuern");
		pts11.setBounds(10, 142, 213, 23);
		panel.add(pts11);
		pts11.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				fire("pts11");
			}
		});
		
		pfr = new JButton("pfr feuern");
		pfr.setBounds(10, 165, 213, 23);
		panel.add(pfr);
		pfr.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				fire("pfr");
			}
		});
		
		textField = new JTextField();
		textField.setBounds(10, 190, 86, 20);
		panel.add(textField);
		textField.setColumns(10);
		
		other = new JButton("feuern");
		other.setBounds(106, 189, 117, 23);
		panel.add(other);
		other.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				fire(textField.getText());
			}
		});
		
		track = new JRadioButton("TrackMEP");
		track.setSelected(true);
		track.setBounds(10, 217, 109, 15);
		panel.add(track);
		
		landmark = new JRadioButton("LandmarkMEP");
		landmark.setBounds(10, 235, 109, 15);
		panel.add(landmark);
		
		region = new JRadioButton("RegionMEP");
		region.setBounds(10, 253, 109, 15);
		panel.add(region);
		
		frame = new JRadioButton("FrameMEP");
		frame.setBounds(10, 271, 109, 15);
		panel.add(frame);
		
		stop = new JRadioButton("StopMEP");
		stop.setBounds(10, 289, 109, 15);
		panel.add(stop);
		
		bg = new ButtonGroup();
		bg.add(frame);
		bg.add(stop);
		bg.add(landmark);
		bg.add(region);
		bg.add(track);
		
		panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null), "Output", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setBounds(252, 11, 232, 133);
		contentPane.add(panel_1);
		panel_1.setLayout(null);
		
		toggleCons = new JToggleButton("Konsolenausgabe");
		toggleCons.setSelected(true);
		toggleCons.setBounds(10, 27, 212, 23);
		panel_1.add(toggleCons);
		toggleCons.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				changeOutput();
			}
		});
		
		toggleAddCons = new JToggleButton("Zus\u00E4tzliche Konsolenausgabe");
		toggleAddCons.setBounds(10, 61, 212, 23);
		panel_1.add(toggleAddCons);
		toggleAddCons.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				changeOutput();
			}
		});
		
		toggleSpeech = new JToggleButton("Sprachausgabe");
		toggleSpeech.setSelected(true);
		toggleSpeech.setBounds(10, 95, 212, 23);
		panel_1.add(toggleSpeech);
		toggleSpeech.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				changeOutput();
			}
		});
		_v = v;
		setVisible(true);
	}
	
	public void setSystem(Vavetam v) {
		_v = v;
	}
	
	private void changeOutput() {
		boolean s = toggleSpeech.isSelected();
		boolean c = toggleCons.isSelected();
		boolean ac = toggleAddCons.isSelected();
		_v.setOutputChannels(s, c, ac);
	}
	
	private void fire(String mep) {
		String type = "";
		if (frame.isSelected()) {
			type = "FRAME";
		}
		if (stop.isSelected()) {
			type = "STOP";
		}
		if (landmark.isSelected()) {
			type = "LANDMARK";
		}
		if (region.isSelected()) {
			type = "REGION";
		}
		if (track.isSelected()) {
			type = "TRACK";
		}
		try {
			_v.fireMapExploratoryProcedure(type, mep);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this, "Es gibt kein RefO mit dieser ID", "Fehler", JOptionPane.ERROR_MESSAGE);
		}
	}
}
