package vavetam.oldcode;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * 
 * @author Ole Eichhorn
 *
 */
public class MyFileWriter {
	
	private BufferedWriter out;

	/**
	 * This method has to be called before adding any lines to the TeX File. It
	 * opens the file to write into and creates the file header.
	 */
	public MyFileWriter(File f, String inName) throws IOException {
		out = new BufferedWriter(new FileWriter(f));
		out.write("%created from xml file "+inName+" with Referential Network conversion tool.\n");
		out.flush();
	}
	
	/**
	 * The specified string is being added as a new line to the TeX File.
	 * 
	 * @param s the new line to be added to the TeX File
	 */
	public void add(String s) throws IOException, IllegalStateException {
		if (out == null) {
			throw new IllegalStateException("there is no open TeX file to write to. Call the openFile method First!");
		}
		out.append(s);
		out.flush();
	}
	
	/**
	 * A blank line is being added to the TeX File.
	 */
	public void blankLine() throws IOException, IllegalStateException {
		if (out == null) {
			throw new IllegalStateException("there is no open TeX file to write to. Call the openFile method First!");
		}
		out.append("\n");
	}
	
	/**
	 * Closes the TeX File. 
	 */
	public void closeFile() throws IOException, IllegalStateException {
		if (out == null) {
			throw new IllegalStateException("there is no open TeX file to close. Call the openFile method First!");
		}
		try {
			out.close();
		} catch (IOException e) {
			System.err.println("couldn't close File properly");
		}
	}
}