package vavetam.oldcode;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Logger;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.UnsupportedAudioFileException;

import marytts.client.MaryClient;
import marytts.client.MaryClient.Voice;
import marytts.client.http.Address;
import marytts.util.data.audio.AudioPlayer;

/*
 * damit das hier funktioniert m�ssen im Java Build Path alle Resscourcen
 * (.jar) aus dem unterordner /java aus der Mary installation eingebunden sein.
 * au�erdem k�nnte es n�tig sein, die Stringkonstante maryserver anzupassen.
 * 
 */
public class SpeechEngineMaryTTS implements SpeechEngine {
	
	private boolean busy = false;
	
	private MaryClient mary;
	private ArrayList<String> voices;
	private String selectedVoice = null;
	private Logger log = Logger.getLogger(SpeechEngineMaryTTS.class.getName());

	public SpeechEngineMaryTTS() throws IOException {
//		Runtime.getRuntime().exec(VavetamConstants.MARY_SERVER);
		mary = MaryClient.getMaryClient(new Address("localhost", 59125));
		voices = new ArrayList<String>();
		for (Voice v: mary.getVoices()) {
			voices.add(v.name());
		}
		selectedVoice = voices.get(0);
		
		
	}
	
	@Override
	public void say(String s) {
	try {
		busy = true;
	    ByteArrayOutputStream baos = new ByteArrayOutputStream();
	    // args: text, inputType, outputType, locale, audioType, defaultVoiceName, output
	    mary.process(s, "TEXT", "AUDIO", "de", "WAVE", selectedVoice, baos);
	    AudioInputStream ais = AudioSystem.getAudioInputStream(
	        new ByteArrayInputStream(baos.toByteArray()));
	    //callback for end of playback
	    LineListener lineListener = new LineListener() {
	        public void update(LineEvent event) {
	            if (event.getType() == LineEvent.Type.STOP) {
	            	pause(600);
	                busy = false;
	            }
	        }
	    };
	    AudioPlayer ap = new AudioPlayer(ais, lineListener);
	    ap.start();
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (UnsupportedAudioFileException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
    
}
 
	
	public void pullDownSpeechEngine() {
		mary = null;
	}

	
	public void setVoice(String voicename) {
		selectedVoice = voicename;
		
	}
	
	
	public boolean isBusy() {
		return busy;
	}
	
	private void pause(int time) {
		try {
			synchronized (this) {
				log.info("Speechout is done verbalizing the last message, pausing now.                <-----END");
				wait(time);
				log.info("Speechout is done pausing and ready to verbalize the next message.                <-----READY");
			}
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public ArrayList<String> getVoices() {
		return voices;
	}
	
	public String getSelectedVoice() {
		return selectedVoice;
	}
}
