package vavetam.implementation.fileio;


import java.util.Collections;

import org.apache.log4j.Logger;

import vavetam.api.structure.IMapExploratoryProcedure;
import vavetam.api.structure.IPreverbalMessage;
import vavetam.implementation.generation.incremental.AbstractPipelineProcessor;
import vavetam.implementation.generation.incremental.FormulationModule;
import vavetam.implementation.structure.MapExploratoryProcedure;
import vavetam.implementation.structure.PreverbalMessage;
import vavetam.implementation.structure.enums.MEPType;


public class DummyIUProducer extends AbstractPipelineProcessor<IPreverbalMessage, IMapExploratoryProcedure> {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		DummyIUProducer dummy = new DummyIUProducer();
		new FormulationModule(dummy, "true", "true");
		PreverbalMessage iu = new PreverbalMessage(null);
		dummy.process(iu);
	}

	@Override
	protected IMapExploratoryProcedure process(IPreverbalMessage in) {
		IMapExploratoryProcedure mep = new MapExploratoryProcedure(MEPType.TRACK, null);
		mep.setPreverbalMessages(Collections.singletonList(in));
		return mep;
	}

	@Override
	protected String threadName() {
		return "Dummy IU Producer";
	}

	@Override
	protected Logger getLogger() {
		return Logger.getLogger(DummyIUProducer.class);
	}
}
